﻿


#Region "Public Class DistrubutionCards ⇒ カードを配布する (ゲームの開始の準備)"
Public Class DistrubutionCards


#Region "Friend Sub New"
    Friend Sub New()

        Randam_Suji(53) 'ランダム数字を発生させて Ar へ格納

    End Sub
#End Region


#Region " Friend Sub Distrubution"
    Friend Sub Distrubution()
        '-----------------------------------------すべてのカードを裏返しで「場」に置く
        Cards_CyuouHaifu()

        System.Threading.Thread.Sleep(1500)
        '-----------------------------------------カードを Player に配布する
        Cards_Haifu()

    End Sub
#End Region


#Region "Cards_CyuouHaifu ⇒ すべてのカードを裏返しで「場」に置く"
    Private Sub Cards_CyuouHaifu()

        For i As Integer = Ar.Count To 1 Step -1
            Card_Show(PictureBox1(3), "ReverseSide.gif", 380 + (i - 1) * 10, 200)
        Next

        Sound(Path2, Alias2)
    End Sub
#End Region


#Region "Cards_Haifu ⇒ カードを Player に配布する"
    Private Sub Cards_Haifu()
        Ar1.Clear() : Ar1.TrimToSize()
        Ar2.Clear() : Ar2.TrimToSize()
        Ar3.Clear() : Ar3.TrimToSize()
        Ar4.Clear() : Ar4.TrimToSize()

        Dim P1 As Integer = 100
        Dim P2 As Integer = 250
        Dim Cnt1 As Integer = 0
        For i As Integer = 1 To Ar.Count
            Select Case i
                Case 1, 5, 9, 13, 17, 21, 25, 29, 33, 37, 41, 45, 49, 53
                    CardsShow1(Cnt1)                                                                                      '「場」に置いたカードを一枚づつ減らす   ↓
                    CardsShow2(i, "ReverseSide.gif", 360 + X1(i) * 10, 90, 100 + X1(i) * 22, 30)                          'カードの軌跡を表示                     ↓
                    Card_Show(PictureBox1(0), "ReverseSide.gif", P1, 7)                                                   'プレイヤー1(ごんた)のカード表示(裏)  << ⇒ 共通事項.vb>>
                    Ar1.Add(Ar.Item(Cnt1))                                                                                'プレイヤー1(ごんた)のカード番号を記録
                Case 2, 6, 10, 14, 18, 22, 26, 30, 34, 38, 42, 46, 50
                    CardsShow1(Cnt1)                                                                                      '「場」に置いたカードを一枚づつ減らす   ↓
                    CardsShow2(i, "ReverseSide.gif", 360 + X1(i) * 10, 90, 600 + X1(i) * 22, 30)                          'カードの軌跡を表示                     ↓
                    Card_Show(PictureBox1(1), "ReverseSide.gif", P1, 7)                                                   'プレイヤー2(みねこ)のカード表示(裏)  << ⇒ 共通事項.vb>>
                    Ar2.Add(Ar.Item(Cnt1))                                                                                'プレイヤー2(みねこ)のカード番号を記録
                Case 3, 7, 11, 15, 19, 23, 27, 31, 35, 39, 43, 47, 51
                    CardsShow1(Cnt1)                                                                                      '「場」に置いたカードを一枚づつ減らす   ↓
                    CardsShow2(i, "ReverseSide.gif", 360 + X1(i) * 30, 90, 1000 + X1(i) * 22, 30)                         'カードの軌跡を表示                     ↓
                    Card_Show(PictureBox1(2), "ReverseSide.gif", P1, 7)                                                   'プレイヤー3(さこん)のカード表示(裏)  << ⇒ 共通事項.vb>>
                    Ar3.Add(Ar.Item(Cnt1))                                                                                'プレイヤー3(さこん)のカード番号を記録

                    P1 += 22
                Case 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52
                    CardsShow1(Cnt1)                                                                                       '「場」に置いたカードを一枚づつ減らす   ↓
                    CardsShow2(i, "Card (" & CInt(Ar.Item(i - 1)) & ").gif", 270 + X1(i) * 70, 390, 270 + X1(i) * 70, 390) 'カードの軌跡を表示                     ↓
                    Card_Show(PictureBox1(4), "Card (" & CInt(Ar.Item(Cnt1)) & ").gif", P2, 6)                             'プレイヤー4(ぼく・わたし)のカード表示(表)  << ⇒ 共通事項.vb>>
                    Ar4.Add(Ar.Item(Cnt1))                                                                                 'プレイヤー4(ぼく・わたし)のカード番号を記録

                    P2 += 72
            End Select

            Cnt1 += 1
            Sound(Path1, Alias1)
            System.Threading.Thread.Sleep(150)
        Next

        Sound(Path4, Alias4)
        System.Threading.Thread.Sleep(1000)
    End Sub


#Region "Private Sub CardsShow1 ⇒ 「場」に置いたカードを一枚づつ減らす"
    Private Sub CardsShow1(Cnt1 As Integer)
        Dim X1 As Integer = 380 + Cnt1 * 6

        PictureBox1(3).Refresh()
        Dim Cnt As Integer = 52 - Cnt1
        For i As Integer = Cnt To 1 Step -1
            Card_Show(PictureBox1(3), "ReverseSide.gif", X1 + (i - 1) * 10, 200)
        Next
    End Sub
#End Region

#Region "Private Sub CardsShow2 ⇒ カードの軌跡を表示"
    Private Sub CardsShow2(i As Integer, Card1 As String, a1 As Integer, b1 As Integer, a2 As Integer, b2 As Integer)
        '-----------------------------------------Position1
        System.Threading.Thread.Sleep(40)
        Card_Show(PictureBox1(3), "ReverseSide.gif", a1, b1)
        System.Threading.Thread.Sleep(40)
        Card_Show(PictureBox1(3), "GreenCard.gif", a1, b1)

        '-----------------------------------------Position2
        System.Threading.Thread.Sleep(40)
        Card_Show(PictureBox1(3), Card1, a2, b2)
        System.Threading.Thread.Sleep(80)
        Card_Show(PictureBox1(3), "GreenCard.gif", a2, b2)
    End Sub
#End Region

#Region "Private Function X1(i As Integer) As Integer"
    Private Function X1(i As Integer) As Integer
        X1 = -1

        Select Case i
            Case 1 To 4
                X1 = 0
            Case 5 To 8
                X1 = 1
            Case 9 To 12
                X1 = 2
            Case 13 To 16
                X1 = 3
            Case 17 To 20
                X1 = 4
            Case 21 To 24
                X1 = 5
            Case 25 To 28
                X1 = 6
            Case 29 To 32
                X1 = 7
            Case 33 To 36
                X1 = 8
            Case 37 To 40
                X1 = 9
            Case 41 To 44
                X1 = 10
            Case 45 To 48
                X1 = 11
            Case 49 To 52
                X1 = 12
            Case 53
                X1 = 13
        End Select

        Return X1
    End Function
#End Region



#End Region


End Class
#End Region


#Region "Public Class PullinCard ⇒ カードを引く"
Public Class PullinCard
    Dim ArrayList1 As ArrayList = New ArrayList
    Dim CardNum As Integer = -1
    Dim Str1 As String = ""
    Dim PlayerD As String = ""               'カードを引き抜かれたプレイヤー

    Dim FinishPlayer1 As Boolean = False     '終了チェック用
    Dim FinishPlayer2 As Boolean = False
    Dim FinishPlayer3 As Boolean = False
    Dim FinishPlayer4 As Boolean = False


#Region "Friend Sub New"
    Friend Sub New(Player As String)
        Dim Cnt1 As Integer = -1
        ArrayList1.Clear() : ArrayList1.TrimToSize()

        Select Case Player
            Case "Player1" '-----------------------------ごんた
                If Ar4.Count >= 1 Then
                    ArrayList1 = Ar4.Clone
                    Cnt1 = Ar4.Count
                    Str1 = "「ごんた」が　「ぼく・わたし」 から カードを引きます。"
                    PlayerD = "Player4"
                ElseIf Ar4.Count = 0 Then
                    If Ar3.Count >= 1 Then
                        ArrayList1 = Ar3.Clone
                        Cnt1 = Ar3.Count
                        Str1 = "「ごんた」が　「さこん」 から カードを引きます。"
                        PlayerD = "Player3"
                    ElseIf Ar3.Count = 0 Then
                        If Ar2.Count >= 1 Then
                            ArrayList1 = Ar2.Clone
                            Cnt1 = Ar2.Count
                            Str1 = "「ごんた」が　「みねこ」 から カードを引きます。"
                            PlayerD = "Player2"
                        ElseIf Ar2.Count = 0 Then
                            PlayerD = ""
                            Exit Sub
                        End If
                    End If
                End If
            Case "Player2" '-----------------------------みねこ
                If Ar1.Count >= 1 Then
                    ArrayList1 = Ar1.Clone
                    Cnt1 = Ar1.Count
                    Str1 = "「みねこ」が　「ごんた」 から カードを引きます。"
                    PlayerD = "Player1"
                ElseIf Ar1.Count = 0 Then
                    If Ar4.Count >= 1 Then
                        ArrayList1 = Ar4.Clone
                        Cnt1 = Ar4.Count
                        Str1 = "「みねこ」が　「ぼく・わたし」 から カードを引きます。"
                        PlayerD = "Player4"
                    ElseIf Ar4.Count = 0 Then
                        If Ar3.Count >= 1 Then
                            ArrayList1 = Ar3.Clone
                            Cnt1 = Ar3.Count
                            Str1 = "「みねこ」が　「さこん」 から カードを引きます。"
                            PlayerD = "Player3"
                        ElseIf Ar3.Count = 0 Then
                            PlayerD = ""
                            Exit Sub
                        End If
                    End If
                End If
            Case "Player3" '-----------------------------さこん
                If Ar2.Count >= 1 Then
                    ArrayList1 = Ar2.Clone
                    Cnt1 = Ar2.Count
                    Str1 = "「さこん」が　「みねこ」 から カードを引きます。"
                    PlayerD = "Player2"
                ElseIf Ar2.Count = 0 Then
                    If Ar1.Count >= 1 Then
                        ArrayList1 = Ar1.Clone
                        Cnt1 = Ar1.Count
                        Str1 = "「さこん」が　「ごんた」 から カードを引きます。"
                        PlayerD = "Player1"
                    ElseIf Ar1.Count = 0 Then
                        If Ar4.Count >= 1 Then
                            ArrayList1 = Ar4.Clone
                            Cnt1 = Ar4.Count
                            Str1 = "「さこん」が　「ぼく・わたし」 から カードを引きます。"
                            PlayerD = "Player4"
                        ElseIf Ar4.Count = 0 Then
                            PlayerD = ""
                            Exit Sub
                        End If
                    End If
                End If
            Case "Player4" '-----------------------------ぼく・わたし
                If Ar3.Count >= 1 Then
                    ArrayList1 = Ar3.Clone
                    Cnt1 = Ar3.Count
                    Str1 = "「ぼく・わたし」が　「さこん」 から カードを引きます。"
                    PlayerD = "Player3"
                ElseIf Ar3.Count = 0 Then
                    If Ar2.Count >= 1 Then
                        ArrayList1 = Ar2.Clone
                        Cnt1 = Ar2.Count
                        Str1 = "「ぼく・わたし」が　「みねこ」 から カードを引きます。"
                        PlayerD = "Player2"
                    ElseIf Ar2.Count = 0 Then
                        If Ar1.Count >= 1 Then
                            ArrayList1 = Ar1.Clone
                            Cnt1 = Ar1.Count
                            Str1 = "「ぼく・わたし」が　「ごんた」 から カードを引きます。"
                            PlayerD = "Player1"
                        ElseIf Ar1.Count = 0 Then
                            PlayerD = ""
                            Exit Sub
                        End If
                    End If
                End If
        End Select

        Randam_Suji(Cnt1)                                      'ランダム数字を発生させて Ar へ格納
        Dim Index1 As Integer = CInt(Ar.Item(0)) - 1
        CardNum = ArrayList1.Item(Index1)                      '引いてくるカード番号

    End Sub
#End Region


#Region " Friend Sub Pullin1 ⇒ 「ごんた」 カードを引く"
    Friend Sub Pullin1()
        If PlayerD = "" Then Exit Sub

        LabelA.Text = Str1
        LabelA.Update()
        System.Threading.Thread.Sleep(500)

        '◆カードを引かれた「Player」の処理◆
        If PlayerD = "Player2" Then '------------------------------------「みねこ」からカードを引く場合
            Ar2.Remove(CardNum)                                           '抜き取ったカードをAr2から削除する
            Narabikae_Player2()                                           '抜き取った後のカードを並び替える ↓
            Kiseki_Player2()                                              'カードの引き抜き軌跡を描く (みねこ側)
            If Ar2.Count = 0 Then
                FinishPlayer2 = True                                      '終了チェック用
            End If
        ElseIf PlayerD = "Player3" Then '--------------------------------「さこん」からカードを引く場合
            Ar3.Remove(CardNum)
            Narabikae_Player3()
            Kiseki_Player3()
            If Ar3.Count = 0 Then
                FinishPlayer3 = True
            End If
        ElseIf PlayerD = "Player4" Then '---------------------------------「ぼく・わたし」からカードを引く場合
            Ar4.Remove(CardNum)
            Narabikae_Player4()
            Kiseki_Player4()
            If Ar4.Count = 0 Then
                FinishPlayer4 = True
            End If
        End If

        '◆カードの引き抜き軌跡を描く  (ごんた側)◆
        Kiseki_Player1()

        '◆カードを追加する◆
        Ar1.Add(CardNum)

        '◆追加後のカードを並び替える◆
        System.Threading.Thread.Sleep(100)
        Narabikae_Player1()
        System.Threading.Thread.Sleep(1000)

        LabelA.Text = "「ごんた」がカードを切ります。"
        LabelA.Update()

        '◆カードを引かれカードが0枚になったことによる終了チェック◆
        Finish_Check()
    End Sub
#End Region

#Region "Friend Sub Pullin2 ⇒ 「みねこ」 カードを引く"
    Friend Sub Pullin2()
        If PlayerD = "" Then Exit Sub

        LabelA.Text = Str1
        LabelA.Update()
        System.Threading.Thread.Sleep(500)

        '◆カードを引かれた Player の処理◆
        If PlayerD = "Player1" Then            '------------------------「ごんた」からカードを引く場合
            Ar1.Remove(CardNum)                                           '抜き取ったカードをAr1から削除する
            Narabikae_Player1()                                           '抜き取った後のカードを並び替える      ↓
            Kiseki_Player1()                                              'カードの引き抜き軌跡を描く (ごんた側) ↓
            If Ar1.Count = 0 Then
                FinishPlayer1 = True
            End If
        ElseIf PlayerD = "Player3" Then        '------------------------「さこん」からカードを引く場合
            Ar3.Remove(CardNum)
            Narabikae_Player3()
            Kiseki_Player3()
            If Ar3.Count = 0 Then
                FinishPlayer3 = True
            End If
        ElseIf PlayerD = "Player4" Then        '------------------------「ぼく・わたし」からカードを引く場合
            Ar4.Remove(CardNum)
            Narabikae_Player4()
            Kiseki_Player4()
            If Ar4.Count = 0 Then
                FinishPlayer4 = True
            End If
        End If

        '◆カードの引き抜き軌跡を描く  (みねこ側)◆
        Kiseki_Player2()

        '◆カードを追加する◆
        Ar2.Add(CardNum)

        '◆追加後のカードを並び替える◆
        System.Threading.Thread.Sleep(100)
        Narabikae_Player2()
        System.Threading.Thread.Sleep(1000)

        LabelA.Text = "「みねこ」がカードを切ります。"
        LabelA.Update()

        '◆カードを引かれカードが0枚になったことによる終了チェック◆
        Finish_Check()   '↓
    End Sub
#End Region

#Region "Friend Sub Pullin3 ⇒ 「さこん」 カードを引く"
    Friend Sub Pullin3()
        If PlayerD = "" Then Exit Sub

        LabelA.Text = Str1
        LabelA.Update()

        '◆カードを引かれた Player の処理◆
        System.Threading.Thread.Sleep(500)
        If PlayerD = "Player1" Then                       '-------------「ごんた」からカードを引く場合
            Ar1.Remove(CardNum)                                           '抜き取ったカードをAr1から削除する
            Narabikae_Player1()                                           '抜き取った後のカードを並び替える      ↓
            Kiseki_Player1()                                              'カードの引き抜き軌跡を描く (ごんた側) ↓
            If Ar1.Count = 0 Then
                FinishPlayer1 = True
            End If
        ElseIf PlayerD = "Player2" Then                   '-------------「みねこ」からカードを引く場合
            Ar2.Remove(CardNum)
            Narabikae_Player2()
            Kiseki_Player2()
            If Ar2.Count = 0 Then
                FinishPlayer2 = True
            End If
        ElseIf PlayerD = "Player4" Then                   '-------------「ぼく・わたし」からカードを引く場合
            Ar4.Remove(CardNum)
            Narabikae_Player4()
            Kiseki_Player4()
            If Ar4.Count = 0 Then
                FinishPlayer4 = True
            End If
        End If

        '◆カードの引き抜き軌跡を描く  (さこん側)◆
        Kiseki_Player3()

        '◆カードを追加する◆
        Ar3.Add(CardNum)

        '◆追加後のカードを並び替える◆
        System.Threading.Thread.Sleep(100)
        Narabikae_Player3()
        System.Threading.Thread.Sleep(1000)

        LabelA.Text = "「さこん」がカードを切ります。"
        LabelA.Update()

        '◆カードを引かれカードが0枚になったことによる終了チェック◆
        Finish_Check()   '↓
    End Sub
#End Region

#Region "Friend Sub Pullin4 ⇒ ぼく・わたし カードを引く"
    Friend Sub Pullin4()
        If PlayerD = "" Then Exit Sub

        LabelA.Text = Str1
        LabelA.Update()

        '◆カードを引かれた Player の処理◆
        System.Threading.Thread.Sleep(500)
        If PlayerD = "Player1" Then           '「ごんた」からカードを引く場合
            Ar1.Remove(CardNum)                                           '抜き取ったカードをAr1から削除する
            Narabikae_Player1()                                           '抜き取った後のカードを並び替える      ↓
            Kiseki_Player1()                                              'カードの引き抜き軌跡を描く (ごんた側) ↓
            If Ar1.Count = 0 Then
                FinishPlayer1 = True
            End If
        ElseIf PlayerD = "Player2" Then       '「みねこ」からカードを引く場合
            Ar2.Remove(CardNum)
            Narabikae_Player2()
            Kiseki_Player2()
            If Ar2.Count = 0 Then
                FinishPlayer2 = True
            End If
        ElseIf PlayerD = "Player3" Then       '「さこん」からカードを引く場合
            Ar3.Remove(CardNum)
            Narabikae_Player3()
            Kiseki_Player3()
            If Ar3.Count = 0 Then
                FinishPlayer3 = True
            End If
        End If

        '◆カードの引き抜き軌跡を描く  (ぼく・わたし側)◆
        Kiseki_Player4()

        '◆カードを追加する◆
        Ar4.Add(CardNum)

        '◆追加後のカードを並び替える◆
        System.Threading.Thread.Sleep(100)
        Narabikae_Player4()
        System.Threading.Thread.Sleep(1000)

        LabelA.Text = "切るカードをクリックします。"
        LabelA.Update()

        '◆カードを引かれカードが0枚になったことによる終了チェック◆
        Finish_Check()   '↓
    End Sub
#End Region


#Region "Private Sub Narabikae_Player1 ⇒ 「ごんた」のカード並び替え"
    Private Sub Narabikae_Player1()
        PictureBox1(0).Refresh()
        For i As Integer = 0 To Ar1.Count - 1
            If Item1(8).Checked = True Then
                Card_Show(PictureBox1(0), "Card (" & Ar1.Item(i) & ").gif", 100 + (i * 22), 6)
            ElseIf Item1(8).Checked = False Then
                Card_Show(PictureBox1(0), "ReverseSide.gif", 100 + (i * 22), 6)
            End If
        Next
    End Sub
#End Region

#Region "Private Sub Narabikae_Player2 ⇒ 「みねこ」のカード並び替え"
    Private Sub Narabikae_Player2()
        PictureBox1(1).Refresh()
        For i As Integer = 0 To Ar2.Count - 1
            If Item1(9).Checked = True Then
                Card_Show(PictureBox1(1), "Card (" & Ar2.Item(i) & ").gif", 100 + (i * 22), 6)
            ElseIf Item1(9).Checked = False Then
                Card_Show(PictureBox1(1), "ReverseSide.gif", 100 + (i * 22), 6)
            End If
        Next
    End Sub
#End Region

#Region "Private Sub Narabikae_Player3 ⇒ 「さこん」のカード並び替え"
    Private Sub Narabikae_Player3()
        PictureBox1(2).Refresh()
        For i As Integer = 0 To Ar3.Count - 1
            If Item1(10).Checked = True Then
                Card_Show(PictureBox1(2), "Card (" & Ar3.Item(i) & ").gif", 100 + (i * 22), 6)
            ElseIf Item1(10).Checked = False Then
                Card_Show(PictureBox1(2), "ReverseSide.gif", 100 + (i * 22), 6)
            End If
        Next
    End Sub
#End Region

#Region "Private Sub Narabikae_Player4 ⇒ 「ぼく・わたし」のカード並び替え"
    Private Sub Narabikae_Player4()
        PictureBox1(4).Refresh()
        For i As Integer = 0 To Ar4.Count - 1
            Card_Show(PictureBox1(4), "Card (" & Ar4.Item(i) & ").gif", 250 + (i * 72), 6)
        Next
    End Sub
#End Region


#Region "Private Sub Kiseki_Player1 ⇒ カードの引き抜き軌跡を描く (ごんた側)"
    Private Sub Kiseki_Player1()
        System.Threading.Thread.Sleep(200)
        If Item1(8).Checked = True Then
            Card_Show(PictureBox1(3), "Card (" & CardNum & ").gif", 120 + (Ar1.Count - 1) * 22, 1)
        ElseIf Item1(8).Checked = False Then
            Card_Show(PictureBox1(3), "ReverseSide.gif", 120 + (Ar1.Count - 1) * 22, 1)
        End If

        System.Threading.Thread.Sleep(200)
        Card_Show(PictureBox1(3), "GreenCard.gif", 120 + (Ar1.Count - 1) * 22, 1)

        Sound(Path1, Alias1)
    End Sub
#End Region

#Region "Private Sub Kiseki_Player2 ⇒ カードの引き抜き軌跡を描く (みねこ側)"
    Private Sub Kiseki_Player2()
        System.Threading.Thread.Sleep(200)
        If Item1(9).Checked = True Then
            Card_Show(PictureBox1(3), "Card (" & CardNum & ").gif", 580 + (Ar2.Count - 1) * 22, 1)

        ElseIf Item1(9).Checked = False Then
            Card_Show(PictureBox1(3), "ReverseSide.gif", 580 + (Ar2.Count - 1) * 22, 1)
        End If

        System.Threading.Thread.Sleep(200)
        Card_Show(PictureBox1(3), "GreenCard.gif", 580 + (Ar2.Count - 1) * 22, 1)

        Sound(Path1, Alias1)
    End Sub
#End Region

#Region "Private Sub Kiseki_Player3 ⇒ カードの引き抜き軌跡を描く (さこん側)"
    Private Sub Kiseki_Player3()
        System.Threading.Thread.Sleep(200)
        If Item1(10).Checked = True Then
            Card_Show(PictureBox1(3), "Card (" & CardNum & ").gif", 1040 + (Ar3.Count - 1) * 22, 1)
        ElseIf Item1(10).Checked = False Then
            Card_Show(PictureBox1(3), "ReverseSide.gif", 1040 + (Ar3.Count - 1) * 22, 1)
        End If

        System.Threading.Thread.Sleep(200)
        Card_Show(PictureBox1(3), "GreenCard.gif", 1040 + (Ar3.Count - 1) * 22, 1)

        Sound(Path1, Alias1)
    End Sub
#End Region

#Region "Private Sub Kiseki_Player4 ⇒ カードの引き抜き軌跡を描く (ぼく・わたし側)"
    Private Sub Kiseki_Player4()
        System.Threading.Thread.Sleep(200)
        Card_Show(PictureBox1(3), "Card (" & CardNum & ").gif", 350 + (Ar4.Count - 1) * 72, 385)
        System.Threading.Thread.Sleep(200)
        Card_Show(PictureBox1(3), "GreenCard.gif", 350 + (Ar4.Count - 1) * 72, 385)

        Sound(Path1, Alias1)
    End Sub
#End Region


#Region "Private Sub Finish_Check ⇒ カードを引かれカードが0枚になったことによる終了チェック"
    Private Sub Finish_Check()

        If FinishPlayer1 = True Then
            Syuryo_Check("Player1")
            FinishPlayer1 = False
            Exit Sub
        End If

        If FinishPlayer2 = True Then
            Syuryo_Check("Player2")
            FinishPlayer2 = False
            Exit Sub
        End If

        If FinishPlayer3 = True Then
            Syuryo_Check("Player3")
            FinishPlayer3 = False
            Exit Sub
        End If

        If FinishPlayer4 = True Then
            Syuryo_Check("Player4")
            FinishPlayer4 = False
            Exit Sub
        End If

    End Sub
#End Region


End Class
#End Region


#Region "Public Class PlayCard ⇒ カードを処理する"
Public Class PlayCard
    Dim CardNum1 As Integer = -1                                         '切るカード番号1枚目
    Dim CardNum2 As Integer = -1                                         '   〃         2枚目


#Region "Friend Sub New"
    Friend Sub New(Player As String)
        Select Case Player
            Case "Player1" '-----------------------------ごんた
                Dim PullinCard1 As PullinCard = New PullinCard("Player1")
                PullinCard1.Pullin1()                                         'カードを引く  << ⇒ カード.vb>>

                Dim Comp1 As Computer = New Computer("Player1")
                Comp1.Keisan()                                                '切るカードを決める << ⇒ 計算.vb>>
                CardNum1 = Comp1.Num1                                         '切るカード番号1枚目
                CardNum2 = Comp1.Num2                                         '   〃         2枚目
            Case "Player2" '-----------------------------みねこ
                Dim PullinCard2 As PullinCard = New PullinCard("Player2")
                PullinCard2.Pullin2()

                Dim Comp2 As Computer = New Computer("Player2")
                Comp2.Keisan()
                CardNum1 = Comp2.Num1
                CardNum2 = Comp2.Num2
            Case "Player3" '-----------------------------さこん
                Dim PullinCard3 As PullinCard = New PullinCard("Player3")
                PullinCard3.Pullin3()

                Dim Comp3 As Computer = New Computer("Player3")
                Comp3.Keisan()
                CardNum1 = Comp3.Num1
                CardNum2 = Comp3.Num2
            Case "Player4" '-----------------------------ぼく・わたし
                Dim PullinCard4 As PullinCard = New PullinCard("Player4")
                PullinCard4.Pullin4()

                Dim Comp4 As Computer = New Computer("Player4")
                Comp4.Keisan()
                CardNum1 = Comp4.Num1
                CardNum2 = Comp4.Num2
        End Select
    End Sub
#End Region


#Region "Friend Sub Player1_Start ⇒ 「ごんた」のカード処理"
    Friend Sub Player1_Start()
        If CardNum1 <> -1 And CardNum2 <> -1 Then '----------<切るカードがある場合>

            '◆切るカード2枚を自分の場で一瞬晒す◆
            PictureBox1(0).Refresh()
            For i As Integer = 0 To Ar1.Count - 1
                Select Case Ar1.Item(i)
                    Case CardNum1
                        Card_Show(PictureBox1(0), "Card (" & CardNum1 & ").gif", 100 + (i * 22), 6)
                    Case CardNum2
                        Card_Show(PictureBox1(0), "Card (" & CardNum2 & ").gif", 100 + (i * 22), 6)
                    Case Else
                        Card_Show(PictureBox1(0), "ReverseSide.gif", 100 + (i * 22), 6)
                End Select
            Next
            Sound(Path2, Alias2)

            '◆切るカード2枚を抜き取って直下の中央の場に晒す◆
            System.Threading.Thread.Sleep(1000)
            Card_Show(PictureBox1(3), "Card (" & CardNum1 & ").gif", 180, 7)
            Card_Show(PictureBox1(3), "Card (" & CardNum2 & ").gif", 255, 7)
            Sound(Path1, Alias1)

            '◆切るカード2枚をAr1から削除する◆
            Ar1.Remove(CardNum1)
            Ar1.Remove(CardNum2)
            Ar1.TrimToSize()

            '◆抜き取った後のカードを並び替える◆
            PictureBox1(0).Refresh()
            For i As Integer = 0 To Ar1.Count - 1
                If Item1(8).Checked = True Then
                    Card_Show(PictureBox1(0), "Card (" & Ar1.Item(i) & ").gif", 100 + (i * 22), 6)
                ElseIf Item1(8).Checked = False Then
                    Card_Show(PictureBox1(0), "ReverseSide.gif", 100 + (i * 22), 6)
                End If
            Next

            '◆抜き取ったカードをAr5に記録する◆
            Ar5.Add(CardNum1)
            Ar5.Add(CardNum2)

            '◆切ったカードを中央に捨てる◆
            System.Threading.Thread.Sleep(300)
            PictureBox1(3).Refresh()
            Dim X1 As Integer = CInt((PictureBox1(3).Width - Ar5.Count * 25) / 2)
            For i As Integer = 0 To Ar5.Count - 1
                Card_Show(PictureBox1(3), "Card (" & Ar5.Item(i) & ").gif", X1, 200)
                X1 += 25
            Next
            Sound(Path1, Alias1)

        ElseIf CardNum1 = -1 Or CardNum2 = -1 Then '----------<切るカードが無い場合>
            Sound(Path3, Alias3)
            MessageBox.Show("ごんた パス")
        End If
    End Sub
#End Region


#Region "Friend Sub Player2_Star ⇒ 「みねこ」のカード処理"
    Friend Sub Player2_Start()
        If CardNum1 <> -1 And CardNum2 <> -1 Then '----------<切るカードがある場合>

            '◆切るカード2枚を自分の場で一瞬晒す◆
            PictureBox1(1).Refresh()
            For i As Integer = 0 To Ar2.Count - 1
                Select Case Ar2.Item(i)
                    Case CardNum1
                        Card_Show(PictureBox1(1), "Card (" & CardNum1 & ").gif", 100 + (i * 22), 6)
                    Case CardNum2
                        Card_Show(PictureBox1(1), "Card (" & CardNum2 & ").gif", 100 + (i * 22), 6)
                    Case Else
                        Card_Show(PictureBox1(1), "ReverseSide.gif", 100 + (i * 22), 6)
                End Select
            Next
            Sound(Path2, Alias2)

            '◆切るカード2枚を抜き取って直下の中央の場に晒す◆
            System.Threading.Thread.Sleep(1000)
            Card_Show(PictureBox1(3), "Card (" & CardNum1 & ").gif", 650, 7)
            Card_Show(PictureBox1(3), "Card (" & CardNum2 & ").gif", 715, 7)
            Sound(Path1, Alias1)

            '◆切るカード2枚をAr2から削除する◆
            Ar2.Remove(CardNum1)
            Ar2.Remove(CardNum2)
            Ar2.TrimToSize()

            '◆抜き取った後のカードを並び替える◆
            PictureBox1(1).Refresh()
            For i As Integer = 0 To Ar2.Count - 1
                If Item1(9).Checked = True Then
                    Card_Show(PictureBox1(1), "Card (" & Ar2.Item(i) & ").gif", 100 + (i * 22), 6)
                ElseIf Item1(9).Checked = False Then
                    Card_Show(PictureBox1(1), "ReverseSide.gif", 100 + (i * 22), 6)
                End If
            Next

            '◆抜き取ったカードをAr5に記録する◆
            Ar5.Add(CardNum1)
            Ar5.Add(CardNum2)

            '◆切ったカードを中央に捨てる◆
            System.Threading.Thread.Sleep(300)
            PictureBox1(3).Refresh()
            Dim X1 As Integer = CInt((PictureBox1(3).Width - Ar5.Count * 25) / 2)
            For i As Integer = 0 To Ar5.Count - 1
                Card_Show(PictureBox1(3), "Card (" & Ar5.Item(i) & ").gif", X1, 200)
                X1 += 25
            Next
            Sound(Path1, Alias1)

        ElseIf CardNum1 = -1 Or CardNum2 = -1 Then '----------<切るカードが無い場合>

            Sound(Path3, Alias3)
            MessageBox.Show("みねこ パス")
        End If
    End Sub
#End Region


#Region "Friend Sub Player3_Start ⇒ 「さこん」のカード処理"
    Friend Sub Player3_Start()
        If CardNum1 <> -1 And CardNum2 <> -1 Then '----------<切るカードがある場合>

            '◆切るカード2枚を自分の場で一瞬晒す◆
            PictureBox1(2).Refresh()
            For i As Integer = 0 To Ar3.Count - 1
                Select Case Ar3.Item(i)
                    Case CardNum1
                        Card_Show(PictureBox1(2), "Card (" & CardNum1 & ").gif", 100 + (i * 22), 6)
                    Case CardNum2
                        Card_Show(PictureBox1(2), "Card (" & CardNum2 & ").gif", 100 + (i * 22), 6)
                    Case Else
                        Card_Show(PictureBox1(2), "ReverseSide.gif", 100 + (i * 22), 6)
                End Select
            Next
            Sound(Path2, Alias2)

            '◆切るカード2枚を抜き取って直下の中央の場に晒す◆
            System.Threading.Thread.Sleep(1000)
            Card_Show(PictureBox1(3), "Card (" & CardNum1 & ").gif", 1100, 7)
            Card_Show(PictureBox1(3), "Card (" & CardNum2 & ").gif", 1175, 7)
            Sound(Path1, Alias1)

            '◆切るカード2枚をAr3から削除する◆
            Ar3.Remove(CardNum1)
            Ar3.Remove(CardNum2)
            Ar3.TrimToSize()

            '◆抜き取った後のカードを並び替える◆
            PictureBox1(2).Refresh()
            For i As Integer = 0 To Ar3.Count - 1
                If Item1(10).Checked = True Then
                    Card_Show(PictureBox1(2), "Card (" & Ar3.Item(i) & ").gif", 100 + (i * 22), 6)
                ElseIf Item1(10).Checked = False Then
                    Card_Show(PictureBox1(2), "ReverseSide.gif", 100 + (i * 22), 6)
                End If
            Next

            '◆抜き取ったカードをAr5に記録する◆
            Ar5.Add(CardNum1)
            Ar5.Add(CardNum2)

            '◆切ったカードを中央に捨てる◆
            System.Threading.Thread.Sleep(300)
            PictureBox1(3).Refresh()
            Dim X1 As Integer = CInt((PictureBox1(3).Width - Ar5.Count * 25) / 2)
            For i As Integer = 0 To Ar5.Count - 1
                Card_Show(PictureBox1(3), "Card (" & Ar5.Item(i) & ").gif", X1, 200) '切ったカードを中央に捨てる
                X1 += 25
            Next
            Sound(Path1, Alias1)

        ElseIf CardNum1 = -1 Or CardNum2 = -1 Then '----------<切るカードが無い場合>

            Sound(Path3, Alias3)
            MessageBox.Show("さこん パス")

        End If
    End Sub
#End Region


#Region "Friend Sub Player4_Start ⇒ 「ぼく・わたし」のカード処理"
    Friend Sub Player4_Start()
        If CardNum1 <> -1 And CardNum2 <> -1 Then
            Exit Sub
        ElseIf CardNum1 = -1 Or CardNum2 = -1 Then

            Sound(Path3, Alias3)
            MessageBox.Show("ぼく・わたし パス")

            Form1.Play_Start1()
        End If
    End Sub
#End Region


End Class
#End Region


