﻿


#Region "Public Class Computer ⇒ 切ることの出来るカード番号を計算する"
Public Class Computer
    Dim ArrayList1 As ArrayList = New ArrayList

    Dim _Num1 As Integer = -1
    Dim _Num2 As Integer = -1


#Region "Friend Sub New"
    Friend Sub New(Player As String)
        ArrayList1.Clear() : ArrayList1.TrimToSize()

        Select Case Player
            Case "Player1"
                ArrayList1 = Ar1.Clone
            Case "Player2"
                ArrayList1 = Ar2.Clone
            Case "Player3"
                ArrayList1 = Ar3.Clone
            Case "Player4"
                ArrayList1 = Ar4.Clone
        End Select

    End Sub
#End Region


#Region "Friend ReadOnly Property Num1 As Integer"
    Friend ReadOnly Property Num1 As Integer
        Get
            Return _Num1   '実際に切るカード番号
        End Get
    End Property

    Friend ReadOnly Property Num2 As Integer
        Get
            Return _Num2   '実際に切るカード番号
        End Get
    End Property
#End Region


#Region "Friend Sub Keisan ⇒ Player1～3用"
    Friend Sub Keisan()
        _Num1 = -1
        _Num2 = -1

        Dim N1 As Integer = -1
        Dim N2 As Integer = -1
        Dim N3 As Integer = -1
        Dim N4 As Integer = -1

        For Each Number1 As Integer In ArrayList1
            Select Case Number1
                Case 1 To 13
                    N1 = Number1
                    N2 = Number1 + 13
                    N3 = Number1 + 26
                    N4 = Number1 + 39

                    If ArrayList1.Contains(N2) Then
                        _Num1 = N1
                        _Num2 = N2
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N3) Then
                        _Num1 = N1
                        _Num2 = N3
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N4) Then
                        _Num1 = N1
                        _Num2 = N4
                        Exit Sub
                    End If

                Case 14 To 26
                    N1 = Number1 - 13
                    N2 = Number1
                    N3 = Number1 + 13
                    N4 = Number1 + 26

                    If ArrayList1.Contains(N1) Then
                        _Num1 = N2
                        _Num2 = N1
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N3) Then
                        _Num1 = N2
                        _Num2 = N3
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N4) Then
                        _Num1 = N2
                        _Num2 = N4
                        Exit Sub
                    End If

                Case 27 To 39
                    N1 = Number1 - 26
                    N2 = Number1 - 13
                    N3 = Number1
                    N4 = Number1 + 13

                    If ArrayList1.Contains(N1) Then
                        _Num1 = N3
                        _Num2 = N1
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N2) Then
                        _Num1 = N3
                        _Num2 = N2
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N4) Then
                        _Num1 = N3
                        _Num2 = N4
                        Exit Sub
                    End If

                Case 40 To 52
                    N1 = Number1 - 39
                    N2 = Number1 - 26
                    N3 = Number1 - 13
                    N4 = Number1

                    If ArrayList1.Contains(N1) Then
                        _Num1 = N4
                        _Num2 = N1
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N2) Then
                        _Num1 = N4
                        _Num2 = N2
                        Exit Sub
                    End If
                    If ArrayList1.Contains(N3) Then
                        _Num1 = N4
                        _Num2 = N3
                        Exit Sub
                    End If
            End Select
        Next

    End Sub
#End Region


#Region "Friend Sub Keisan2 ⇒ Player4用"
    Friend Sub Keisan2(Number1 As Integer)
        _Num1 = -1
        _Num2 = -1

        Dim N1 As Integer = -1
        Dim N2 As Integer = -1
        Dim N3 As Integer = -1
        Dim N4 As Integer = -1

        Select Case Number1
            Case 1 To 13
                N1 = Number1
                N2 = Number1 + 13
                N3 = Number1 + 26
                N4 = Number1 + 39

                If ArrayList1.Contains(N2) Then
                    _Num1 = N1
                    _Num2 = N2
                    Exit Sub
                End If
                If ArrayList1.Contains(N3) Then
                    _Num1 = N1
                    _Num2 = N3
                    Exit Sub
                End If
                If ArrayList1.Contains(N4) Then
                    _Num1 = N1
                    _Num2 = N4
                    Exit Sub
                End If
            Case 14 To 26
                N1 = Number1 - 13
                N2 = Number1
                N3 = Number1 + 13
                N4 = Number1 + 26

                If ArrayList1.Contains(N1) Then
                    _Num1 = N2
                    _Num2 = N1
                    Exit Sub
                End If
                If ArrayList1.Contains(N3) Then
                    _Num1 = N2
                    _Num2 = N3
                    Exit Sub
                End If
                If ArrayList1.Contains(N4) Then
                    _Num1 = N2
                    _Num2 = N4
                    Exit Sub
                End If
            Case 27 To 39
                N1 = Number1 - 26
                N2 = Number1 - 13
                N3 = Number1
                N4 = Number1 + 13

                If ArrayList1.Contains(N1) Then
                    _Num1 = N3
                    _Num2 = N1
                    Exit Sub
                End If
                If ArrayList1.Contains(N2) Then
                    _Num1 = N3
                    _Num2 = N2
                    Exit Sub
                End If
                If ArrayList1.Contains(N4) Then
                    _Num1 = N3
                    _Num2 = N4
                    Exit Sub
                End If
            Case 40 To 52
                N1 = Number1 - 39
                N2 = Number1 - 26
                N3 = Number1 - 13
                N4 = Number1

                If ArrayList1.Contains(N1) Then
                    _Num1 = N4
                    _Num2 = N1
                    Exit Sub
                End If
                If ArrayList1.Contains(N2) Then
                    _Num1 = N4
                    _Num2 = N2
                    Exit Sub
                End If
                If ArrayList1.Contains(N3) Then
                    _Num1 = N4
                    _Num2 = N3
                    Exit Sub
                End If
        End Select

    End Sub
#End Region


End Class
#End Region

