﻿


#Region "Common_Page ⇒ 共通事項"
Module Common_Page
    Friend Screen_Width As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width   '⇒1920
    Friend Screen_Height As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height '⇒1200

    Friend FPath1 As String = Application.StartupPath & "\ババ抜きData\イラスト\"
    Friend FPath2 As String = Application.StartupPath & "\ババ抜きData\カード\"
    Friend FPath3 As String = Application.StartupPath & "\ババ抜きData\効果音\"

    Friend Ar As ArrayList = New ArrayList  'シャッフルした全カードを記録

    Friend Ar1 As ArrayList = New ArrayList '配布した「ごんた」のカードを記録
    Friend Ar2 As ArrayList = New ArrayList '配布した「みねこ」のカードを記録
    Friend Ar3 As ArrayList = New ArrayList '配布した「さこん」のカードを記録
    Friend Ar4 As ArrayList = New ArrayList '配布した「ぼく・わたし」のカードを記録

    Friend Ar5 As ArrayList = New ArrayList '場に捨てたカードを記録

    Friend Jyuni As Integer = 1             '順位をカウント


#Region "◆ランダム数字の発生◆"
    Friend Sub Randam_Suji(MaxSuji As Integer)
        Dim N As Integer = MaxSuji

        Dim t, j, i As Integer
        Dim r(N) As Integer
        Randomize()

        For i = 1 To N
            r(i) = i
        Next

        For i = N To 2 Step -1
            j = CInt((i - 1) * Rnd() + 1)
            t = r(i) : r(i) = r(j) : r(j) = t
        Next

        Ar.Clear() : Ar.TrimToSize()
        For i = 1 To N
            Ar.Add(r(i))        '生成したランダム数字をArに格納する
        Next
    End Sub
#End Region


#Region "◆カードの表示◆"
    Friend Sub Card_Show(Pic1 As PictureBox, Card1 As String, X As Integer, Y As Integer)
        Try
            Dim Graphics1 As Graphics = Pic1.CreateGraphics()
            Dim Image1 = New Bitmap(FPath2 & Card1)

            Graphics1.DrawImage(Image1, X, Y)

            Image1.Dispose()
            Graphics1.Dispose()

        Catch ex As Exception
            MessageBox.Show("カードの表示のエラー")
            Exit Sub
        End Try
    End Sub
#End Region


#Region "◆終了チェック◆"
    Friend Sub Syuryo_Check(Player As String)
        Sound(Path4, Alias4)

        Dim LabelB0 As Label = Nothing
        Select Case Player
            Case "Player1"
                LabelB1_Add()
                LabelB0 = LabelB1

                If Ar1.Count = 1 And (Ar2.Count + Ar3.Count + Ar4.Count = 0) Then '最終終了の場合
                    LabelB1.SetBounds(200, 50, 200, 30)                           'カードと順位文字が重なるので文字位置をずらす
                    PictureBox1(0).Refresh()
                    Card_Show(PictureBox1(0), "Card (53).gif", 100, 7)            'Joker の表を表示
                End If
            Case "Player2"
                LabelB2_Add()
                LabelB0 = LabelB2

                If Ar2.Count = 1 And (Ar1.Count + Ar3.Count + Ar4.Count = 0) Then
                    LabelB2.SetBounds(200, 50, 200, 30)
                    PictureBox1(1).Refresh()
                    Card_Show(PictureBox1(1), "Card (53).gif", 100, 7)
                End If
            Case "Player3"
                LabelB3_Add()
                LabelB0 = LabelB3

                If Ar3.Count = 1 And (Ar1.Count + Ar2.Count + Ar4.Count = 0) Then
                    LabelB3.SetBounds(200, 50, 200, 30)
                    PictureBox1(2).Refresh()
                    Card_Show(PictureBox1(2), "Card (53).gif", 100, 7)
                End If
            Case "Player4"
                LabelB4_Add()
                LabelB0 = LabelB4
        End Select

        For i As Integer = 0 To 4 '文字を点滅させる
            Select Case i
                Case 0, 2, 4
                    LabelB0.Text = Name1(Player) & "  第　" & Jyuni & "  位"
                Case 1, 3
                    LabelB0.Text = ""
            End Select
            LabelB0.Update()
            System.Threading.Thread.Sleep(500)
        Next

        Jyuni += 1
    End Sub


#Region "★Private Function Name1★"
    Private Function Name1(Str As String) As String
        Name1 = ""

        Select Case Str
            Case "Player1"
                Name1 = "ごんた"
            Case "Player2"
                Name1 = "みねこ"
            Case "Player3"
                Name1 = "さこん"
            Case "Player4"
                Name1 = "ぼく・わたし"
        End Select

        Return Name1
    End Function
#End Region

#End Region


#Region "◆効果音・ＢＧＭ◆"
    Friend Path0 As String = FPath3 & "BGM.mp3"       'ＢＧＭ
    Friend Path1 As String = FPath3 & "CLICK.mp3"     'クリック
    Friend Path2 As String = FPath3 & "OK.mp3"        'OK 音
    Friend Path3 As String = FPath3 & "NO.mp3"        'NO 音
    Friend Path4 As String = FPath3 & "END.mp3"       '勝負ありの音
    Friend Path5 As String = FPath3 & "Kido.mp3"      '起動・終了音

    Friend Alias0 As String = "sound0"                '別名(ＢＧＭ)
    Friend Alias1 As String = "sound1"                '別名(クリック)
    Friend Alias2 As String = "sound2"                '別名(OK 音)
    Friend Alias3 As String = "sound3"                '別名(NO 音)
    Friend Alias4 As String = "sound4"                '別名(勝負ありの音)
    Friend Alias5 As String = "sound5"                '別名(Joker)

    Friend Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" _
          (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, _
           ByVal uReturnLength As Integer, ByVal hwndCallback As Integer) As Integer


    Friend Sub Sound(ByVal Path As String, ByVal AliasD As String)

        If mciSendString("stop " & AliasD, "", 0, 0) = 0 Then                         '当該音楽ファイルが <stop> 状態で、<close>していない場合は
            mciSendString("close " & AliasD, "", 0, 0)                                '当該音楽ファイルを一旦閉じる
        End If

        '----------------------------------効果音の場合
        If AliasD = "sound1" Or AliasD = "sound2" Or AliasD = "sound3" Or AliasD = "sound4" Or AliasD = "sound5" Or AliasD = "sound6" Then
            If Item1(6).Checked = True Then
                mciSendString(String.Format("open ""{0}"" alias " & AliasD, Path), "", 0, 0)  '音楽ファイルを開く
                mciSendString("play " & AliasD, "", 0, 0)                                     '再生を開始
            End If
        End If

        '-----------------------------------BGMの場合は繰返し (タイマーで管理)
        If AliasD = "sound0" Then
            mciSendString(String.Format("open ""{0}"" alias " & AliasD, Path), "", 0, 0)  '音楽ファイルを開く
            mciSendString("play " & AliasD, "", 0, 0)                                     '再生を開始

            AddHandler Timer1.Tick, AddressOf Timer1_Tick
            Timer1.Interval = 1000
            Timer1.Enabled = True
        End If

    End Sub


#Region "タイマー"
    Dim Timer1 As Timer = New Timer

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        '-----------------------------------BGMの場合のみ繰返し
        Dim Buffer As String = New String(Chr(0), 255)
        Dim Mode As String
        mciSendString("status sound0 mode", Buffer, Len(Buffer), 0)
        Mode = Replace(Buffer, Chr(0), "")

        If Mode = "stopped" Then '停止状態で繰返し
            Sound(Path0, Alias0)
        End If

    End Sub
#End Region


#End Region


End Module
#End Region
